
QGIS Application - Bug report #8192

Zoom to Layer zooms to a far too large area

2013-06-28 09:49 AM - Aren Cambre

Status: Closed

Priority: Low

Assignee:

Category: GUI

Affected QGIS version:master Regression?: No

Operating System: Windows 7 x64 Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 17010

Description

I have a point layer with a filter applied. If I use the Zoom to Layer feature with that layer selected, it zooms as if the filter was not

applied.

The attached image shows the result of Zoom to Layer. You can clearly see that the layer's green dots are only in a band along I-45 in

Texas, with a couple more towards the Gulf Coast. If I had no filter applied, you'd see green dots all over the state.

To be clear, I don't know if the problem is because of the filter. It seems that if QGIS is working correctly, it should apply the filter using

SQL and should not have knowledge of the filtered out points, so it may be possible that Zoom to Layer may be zooming to the largest

layer on the screen instead of just to the selected layer. If that is true, then Zoom to Layer is either misnamed or broken.

I am on 1.9 c8d3fa7.

Associated revisions

Revision 7608faf6 - 2013-08-04 02:22 PM - Nyall Dawson

Skip missing geometries when calculating extent (fixes #8192, #8194)

Revision 6149b3a6 - 2013-08-07 03:17 AM - Nyall Dawson

Merge pull request #789 from nyalldawson/bug8192

Fix bounding box calculation for features with NULL geometry (fixes #8192, #8194)

History

#1 - 2013-06-29 08:35 AM - Giovanni Manghi

- Status changed from Open to Feedback

It works as expected here.

What datasource are you using? I tested shapes and postgis on qgis/master on Linux.

#2 - 2013-07-04 08:48 PM - Aren Cambre

I am using a datasource that shows events along roadways. Doesn't matter what filter I apply, the zoom extent for Zoom to Layer is hugely greater than
what is needed.

Do you have any "point" datasets with where you can filter to a small area?

I tried on a PostGIS multiline datasource and couldn't reproduce.

#3 - 2013-07-05 02:09 AM - Giovanni Manghi

Aren Cambre wrote:

Do you have any "point" datasets with where you can filter to a small area?

any point layer, of any datasource, I tested works fine here. Unless you can share a sample of the problematic data, it will be hard to prove it is a qgis issue

and not a data one.

#4 - 2013-07-05 06:18 PM - Aren Cambre

I have a SQL dump of the PostGIS datasource handy, so I can share it with you. Please email me at aren@arencambre.com to get it.

#5 - 2013-07-07 12:30 AM - Giovanni Manghi

- Resolution set to worksforme

- Status changed from Feedback to Closed

Aren Cambre wrote:

I have a SQL dump of the PostGIS datasource handy, so I can share it with you. Please email me at aren@arencambre.com to get it.

I tested your sample data and query/filter, and the zoom to layer works as expected, zooming only/exactly to filtered features. Please try a clean installation

and/or on another machine. Reopen if you will find the culprit.

#6 - 2013-07-07 06:22 PM - Aren Cambre

- File ScreenCapture_7-7-2013_9.20.08_AM.wmv added

- Status changed from Closed to Reopened

OK, I tried it on another computer and couldn't reproduce. So I went back to the original computer, removed the install by doing these (was installed using

osgeo4w):

    -  Delete C:\\OSGeo4W.

    -  Delete Start Menu entries.

    -  Delete the .gis2 directory in my home directory.

    -  Delete the corresponding entries in the Windows Registry under HKCU.

Then I reinstalled.

Despite this, I still get the same problem. See the attached video, where I only open the problem layer from a clean install.
#7 - 2013-07-09 05:07 AM - Giovanni Manghi

- Priority changed from Normal to Low

- Target version deleted (Version 2.0.0)

- Resolution deleted (worksforme)

Aren Cambre wrote:

OK, I tried it on another computer and couldn't reproduce. So I went back to the original computer, removed the install by doing these (was installed

using osgeo4w):    -  Delete C:\\OSGeo4W.

    -  Delete Start Menu entries.

    -  Delete the .gis2 directory in my home directory.

    -  Delete the corresponding entries in the Windows Registry under HKCU.

Then I reinstalled.

Despite this, I still get the same problem. See the attached video, where I only open the problem layer from a clean install.

Well, you really cleaned your machine, so I don't what to say. I tested 3 machines (two Windows and 1 Linux) and got no issue. You also tested another

machine and no issue. My gut feeling is that is a (weird) local issue. If you agree I would close this ticket until you will find the eventual culprit.

#8 - 2013-07-09 06:45 AM - Aren Cambre

One other fact: both computers were using the same PostGIS database instance. I.e., the computer that worked was connected to PostGIS on the

computer that didn't work.

I guess it could be closed and I can reopen if I find something meaningful to add. Or we could leave it open as low priority for a while?

#9 - 2013-08-04 05:40 AM - Nyall Dawson

Ok, I've figured this one out. It's caused when a filter is applied to a table which returns records with NULL geometry. The offending lines are around

1164-1167 of qgsvectorlayer.cpp:

if ( fet.geometry() ){

 QgsRectangle bb = fet.geometry()->boundingBox();

 rect.combineExtentWith( &bb );

for features with NULL geometry, fet.geometry->boundingBox() was returning QgsRectangle(0,0,0,0). Combining this extent causes the bounding box min

x and y to be set incorrectly to 0.

Pull request #789 fixes this bug, and incidentally fixes #8194 too.

#10 - 2013-08-06 06:17 PM - Nyall Dawson

- Status changed from Reopened to Closed

Fixed in changeset commit:"6149b3a6fa15c0a5cd497c53269bd0f756c837e6".

Files
zoom_to_layer.png 603 KB 2013-06-28 Aren Cambre

ScreenCapture_7-7-2013_9.20.08_AM.wmv 1.32 MB 2013-07-07 Aren Cambre
